
% Precompute features
f = 0;
Nimages = length(Dc);
data.featuresPositive = zeros(Nsc*Nor*Nb*Nb, Nimages*Nrepetitions);
for i = 1:Nimages;
    i
    % Read image
    img = LMimread(Dc, i, LabelMeHOMEIMAGES);
    img = uint8(mean(img,3));
    
    % Size of the target object in the image:
    [x,y] = LMobjectpolygon(Dc(i).annotation, objectTarget);
    
    %objectSizeMin = ([max(y{1})-min(y{1}) max(x{1})-min(x{1})])*desiredHeight/size(img,1);
    objectSizeMin = []; yy =[];
    for ii = 1:length(x)
        objectSizeMin(ii,:) = ([max([y{ii}])-min([y{ii}]) max([x{ii}])-min([x{ii}])])*desiredHeight/size(img,1);
        yy(ii) = min([y{ii}]);
    end
    [foo, polygoninstance] = min(yy);
    %[objectSizeMin, polygoninstance] = min(min(objectSizeMin,[],2),[],1);
    objectSizeMin = objectSizeMin(polygoninstance,:);
    disp(round(objectSizeMin))

    % only consider images with small targets after image rescaling
    if min(objectSizeMin)<14000
        % Multiple crops by centering randomly in one of the instances and cropping
        % at different scales
        for n = 1:Nrepetitions
            n
            if Nrepetitions>1
                % randomize object size:
                %objectSize = fix(objectSizeMin*(1+.25*rand));
                objectSize = fix(objectSizeMin*(1.25+.5*rand));
                %objectSize = min(objectSize,[15 15]);

                % crop and scale the image randomly
                [newannotation, newimg, crop, scaling, err, msg] = LMcookimage(Dc(i).annotation, img, ...
                    'objectname', objectTarget, 'objectsize', objectSize, 'objectlocation', 'random', ...
                    'maximagesize', [desiredHeight desiredWidth], 'polygoninstance', polygoninstance);
                disp(msg)
            else
                [newannotation, newimg] = LMimscale(Dc(i).annotation, img, desiredHeight/size(img,1), 'bilinear');
                objectSize = objectSizeMin;
                err = 0;
            end
            
            
            if size(newimg,1) < desiredHeight/1.25 | size(newimg,2)<desiredWidth/1.25; err=1; end

            if err==0
                clf; LMplot(newannotation, newimg); legend('off'); title([Nimages-i f]);  
                drawnow

                % Compute features:
                [vL, vLind, vG] = features(newimg, Nsc, Nor, Nb);

                % Collect data:
                mask = LMobjectmask(newannotation, size(newimg)); % get masks

                % Record the coordinates of one of the instances randomly
                m = fix(rand*size(mask, 3))+1;
                [y,x] = find(mask(:,:,m)==1);

                if length(x)>0
                    f = f+1;
                    data.featuresPositive(:,f) = vG;
                    data.imagename{f} = [Dc(i).annotation.folder '/' Dc(i).annotation.filename];
                    data.imagendx(f) = i;
                    data.x(f) = median(x);
                    data.y(f) = median(y);
                    data.s(f) = objectSize(1);
                end
            end
        end
    end
end
data.featuresPositive = data.featuresPositive(:, 1:f);
data.imagendx = data.imagendx(:, 1:f);
